var commonjs2 =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

class Modal {
  passComponent(modal) {
    this.open = modal.open;
    this.submit = modal.submit;
    this.cancel = modal.cancel;
  };
}

const ModalService = new Modal();
/* harmony export (immutable) */ __webpack_exports__["a"] = ModalService;


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__modal_service__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__dialog_component__ = __webpack_require__(3);



class Dialog {
  constructor() {
    this.submitText = 'Submit';
    this.cancelText = 'Cancel';
  };

  setConfig(config) {
    if (config.submitText) {
      this.submitText = config.submitText;
    }
    if (config.cancelText) {
      this.cancelText = config.cancelText;
    }
  };

  notice(message, dialogConfig, modalConfig) {
    return this.open('notice', message, dialogConfig, modalConfig);
  };

  warning(message, dialogConfig, modalConfig) {
    return this.open('warning', message, dialogConfig, modalConfig);
  };

  error(message, dialogConfig, modalConfig) {
    return this.open('error', message, dialogConfig, modalConfig);
  };

  success(message, dialogConfig, modalConfig) {
    return this.open('success', message, dialogConfig, modalConfig);
  };

  open(type, message, dialogConfig={}, modalConfig={}) {
    let data = Object.assign({
      title: type[0].toUpperCase() + type.slice(1),
      message,
      submitText: this.submitText,
      cancelText: this.cancelText
    }, dialogConfig);

    return __WEBPACK_IMPORTED_MODULE_0__modal_service__["a" /* ModalService */].open(__WEBPACK_IMPORTED_MODULE_1__dialog_component__["a" /* DialogComponent */], Object.assign({
          backdropClose: true,
          escapeClose: true,
          size: 'md',
          type,
        }, modalConfig, {data})
    );
  }

}

const DialogService = new Dialog();
/* harmony export (immutable) */ __webpack_exports__["a"] = DialogService;


/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = ModalComponent;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__modal_service__ = __webpack_require__(0);


function ModalComponent(Vue) {
  Vue.component('modal', {
    template: `
<div class="modal-container">
    <div class="modal-parent" v-for="(modal, index) in modalList" :style="{zIndex: index+1}" v-on:click="backdropClick()">
        <div class="modal" ref="modals" :class="{'modal--md': modal.config.size=='md','modal--lg':modal.config.size=='lg', 'modal--warning': modal.config.type=='warning','modal--error': modal.config.type=='error','modal--success': modal.config.type=='success' }" v-on:click.stop>
            <container v-bind:is="modal.component" :data="modal.config.data"></container>        
        </div>
    </div>
    <div class="modal-backdrop" ref="backdrop" :style="{zIndex: modalIndex}"></div>
</div>`,

    mounted() {
      __WEBPACK_IMPORTED_MODULE_0__modal_service__["a" /* ModalService */].passComponent(this);
      document.addEventListener('keydown', this.keydownHandler);

    },
    methods: {
      open(component, config) {

        let defer = new ModalPromise();
        // let defer = deferObservable();

        config = Object.assign({
          backdropClose: true,
          size: 'md',
          escapeClose: true,
          type: 'notice'
        }, config);

        if (!this.active && this.modalList.length) {
          this.modalQueue.push({
            component,
            config,
            defer
          });
        } else {
          this.add({
            component,
            config,
            defer
          })
        }
        return defer.defer;
      },
      add(modal) {
        this.modalIndex++;
        this.modalList.push(modal);

        let index = this.modalList.length - 1;

        if (!this.active) this.activate();
        this.animateModalIn(index);
      },

      close(status, data) {
        let index = this.modalIndex,
            modal = this.modalList[index];
        this.modalIndex--;

        setTimeout(() => {
          modal.defer[status ? 'resolve' : 'reject'](data);
        }, index*100);

        this.animateModalOut(index, () => {
          this.modalList = this.modalList.slice(0, index).concat(this.modalList.slice(index+1));
          if (!this.modalList.length && this.modalQueue.length) {
            this.add(this.modalQueue[0]);
            this.modalQueue = [];
          }
        });

        if (this.modalIndex === -1) {
          if (this.modalQueue.length) {
            this.add(this.modalQueue[0]);
            this.modalQueue = [];
          } else {
            this.deactivate();
          }
        }
      }
      ,
      submit(data=null) {
        this.close(true, data);
      },
      cancel(data=null) {
        this.close(false, data);
      },
      animateModalIn(nextModalIndex) {
        // the timeout gives time for the $refs to propagate
        setTimeout(() => {
          let el = this.$refs.modals[nextModalIndex];
          el.classList.add('modal--active');
        }, 100);
      },
      animateModalOut(outModalIndex, cb) {
        let el = this.$refs.modals[outModalIndex];
        el.classList.remove('modal--active');
        setTimeout(cb, 300)
      },
      activate() {
        document.body.classList.add('modal--active');
        this.$refs.backdrop.style.display = 'block';
        setTimeout(() => {
          this.$refs.backdrop.classList.add('active');
        }, 10);
        this.active = true;
      },
      deactivate() {
        this.$refs.backdrop.classList.remove('active');
        setTimeout(() => {
          document.body.classList.remove('modal--active');
          this.$refs.backdrop.style.display = 'none';
        }, 290);
        this.active = false;
      },
      backdropClick() {
        if (this.modalIndex >= 0 && this.modalList[this.modalIndex].config.backdropClose) {
          this.cancel();
        }
      },
      keydownHandler(event) {
        if (event.key === 'Escape' &&
            this.modalIndex >= 0 &&
            this.modalList[this.modalIndex].config.escapeClose){
          this.cancel();
        }
      }
    },
    data() {
      return {
        active: false,
        modalList: [],
        modalIndex: -1,
        modalQueue: []
      }
    },
  });
}

function ModalPromise() {
  let self = this;
  this.resCb = null;
  this.errCb = null;
  this.catchCb = null;

  this.resolve = data => {
    if (this.resCb) this.resCb(data);
  };

  this.reject = data => {
    if (this.errCb) this.errCb(data);
  };

  this.err = data => {
    if (this.catchCb) this.catchCb(data);
  };

  this.defer = {
    then(res=null, err=null) {
      self.resCb = res;
      self.errCb = err;
      return this;
    },
    catch(err=null) {
      self.catchCb = err;
    }
  };
}

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_vue__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_vue__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__modal_service__ = __webpack_require__(0);



const DialogComponent = __WEBPACK_IMPORTED_MODULE_0_vue___default.a.component('dialogComponent', {
  template: `
<div>
    <div class="modal__header" v-show="data.title">
        {{data.title}}
    </div>
    <div class="modal__body">
        {{data.message}}
    </div>
    <div class="modal__footer">
        <button class="btn btn--primary" v-on:click="submit()" v-show="data.submitText">
            {{data.submitText}}
        </button>
        <button class="btn" v-on:click="cancel()" v-show="data.cancelText">
            {{data.cancelText}}
        </button>
    </div>
</div>`,
  props: ['data'],
  methods: {
    submit() {
      __WEBPACK_IMPORTED_MODULE_1__modal_service__["a" /* ModalService */].submit();
    },
    cancel() {
      __WEBPACK_IMPORTED_MODULE_1__modal_service__["a" /* ModalService */].cancel();
    }
  }
});
/* harmony export (immutable) */ __webpack_exports__["a"] = DialogComponent;


/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__modal_component__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__dialog_service__ = __webpack_require__(1);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "DialogService", function() { return __WEBPACK_IMPORTED_MODULE_1__dialog_service__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__modal_service__ = __webpack_require__(0);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "ModalService", function() { return __WEBPACK_IMPORTED_MODULE_2__modal_service__["a"]; });


const VueModalDialog = {
  install(Vue) {
    __webpack_require__.i(__WEBPACK_IMPORTED_MODULE_0__modal_component__["a" /* ModalComponent */])(Vue);
  }
};
/* harmony export (immutable) */ __webpack_exports__["VueModalDialog"] = VueModalDialog;





/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = Vue;

/***/ })
/******/ ]);
//# sourceMappingURL=main.js.map